#Game Tick
gamemode adventure @a[gamemode=survival]
gamemode adventure @a[gamemode=creative]
setworldspawn 500 29 500
execute if score state game matches 1 as @a[scores={cancelled=1..}] at @s run function lobby:cancel
effect give @e[type=slime,nbt=!{ActiveEffects:[{Id:14b}]}] minecraft:invisibility 999999 0 true
effect give @e[type=villager,nbt=!{ActiveEffects:[{Id:14b}]}] minecraft:invisibility 999999 0 true
execute as @e[type=item,nbt={Item:{id:"minecraft:leather_helmet",Count:1b}}] at @s run kill @s
execute as @e[type=item,nbt={Item:{id:"minecraft:player_head"}}] at @s run kill @s

execute if score start_countdown game matches 1.. run scoreboard players remove start_countdown game 1
execute if score start_countdown game matches 100 run title @a title ["",{"text":"Starting Round in...","color":"gold"}]
execute if score start_countdown game matches 100 run title @a times 20 120 5
execute if score start_countdown game matches 100 run title @a subtitle ["",{"text":"...5","color":"dark_gray"}]
execute if score start_countdown game matches 100 as @a at @s run playsound minecraft:block.note_block.xylophone master @s ~ ~ ~ 1 1.5
execute if score start_countdown game matches 080 run title @a subtitle ["",{"text":"...4","color":"dark_gray"}]
execute if score start_countdown game matches 080 as @a at @s run playsound minecraft:block.note_block.xylophone master @s ~ ~ ~ 1 1.0
execute if score start_countdown game matches 060 run title @a subtitle ["",{"text":"...3","color":"dark_gray"}]
execute if score start_countdown game matches 060 as @a at @s run playsound minecraft:block.note_block.xylophone master @s ~ ~ ~ 1 0.8
execute if score start_countdown game matches 040 run title @a subtitle ["",{"text":"...2","color":"dark_gray"}]
execute if score start_countdown game matches 040 as @a at @s run playsound minecraft:block.note_block.xylophone master @s ~ ~ ~ 1 0.6
execute if score start_countdown game matches 020 run title @a subtitle ["",{"text":"...1","color":"dark_gray"}]
execute if score start_countdown game matches 020 as @a[tag=spectate] at @s run tp @s 115 30 -160 0 0
execute if score start_countdown game matches 020 as @a at @s run playsound minecraft:block.note_block.xylophone master @s ~ ~ ~ 1 0.4
execute if score start_countdown game matches 001 run title @a subtitle ["",{"text":"Good Luck","color":"gray"}]
execute if score start_countdown game matches 001 run function game:seeker
execute if score start_countdown game matches 001 run function game:timers
execute if score start_countdown game matches 001 run scoreboard players set state game 2

execute if score state game matches 0 run function lobby:tick
execute if score state game matches 0..2 run function advancements:tick
execute if score state game matches 2 run function hiding:tick
execute if score state game matches 2 run function game:powerups/tick
execute if score state game matches 2 run function game:powerups/functions
execute if score state game matches 2 run function haunted:tick
execute if score state game matches 0 run defaultgamemode adventure
execute if score state game matches 1.. run defaultgamemode spectator

execute if score state game matches 0.. as @a[tag=!lobby] at @s if entity @s[x=450,y=0,z=450,dz=100,dx=100,dy=50] run tag @s add lobby
execute if score state game matches 0.. as @a[tag=lobby] at @s unless entity @s[x=450,y=0,z=450,dz=100,dx=100,dy=50] run tag @s remove lobby
execute if score state game matches 2 as @a[tag=lobby,x=450,y=0,z=450,dz=100,dx=100,dy=50] at @s run gamemode spectator @s
execute if score state game matches 2 as @a[tag=lobby,x=450,y=0,z=450,dz=100,dx=100,dy=50] at @s run tp @s 115 13 -182 0 0

execute if score state game matches 2 store result bossbar round:length value run scoreboard players get round_length game
execute if score state game matches 2 store result bossbar release:delay1 value run scoreboard players get release_delay game
execute if score state game matches 2 store result bossbar release:delay2 value run scoreboard players get release_delay game

execute if score state game matches 2 if score powerups settings matches 0 as @e[type=item,tag=powerup] at @s run kill @s
execute if score state game matches 2 if score powerups settings matches 1 run scoreboard players add powerups game 1
execute if score item_freq settings matches 0 if score powerups game matches 1200.. run function game:powerups/tries
execute if score item_freq settings matches 1 if score powerups game matches 900.. run function game:powerups/tries
execute if score item_freq settings matches 2 if score powerups game matches 300.. run function game:powerups/tries
execute if score item_freq settings matches 3 if score powerups game matches 100.. run function game:powerups/tries
execute if score item_freq settings matches 0 if score powerups game matches 1200.. run scoreboard players set powerups game 0
execute if score item_freq settings matches 1 if score powerups game matches 900.. run scoreboard players set powerups game 0
execute if score item_freq settings matches 2 if score powerups game matches 300.. run scoreboard players set powerups game 0
execute if score item_freq settings matches 3 if score powerups game matches 100.. run scoreboard players set powerups game 0

execute if score state game matches 2 if score haunted_rooms settings matches 0 if score haunted_rooms game matches 1.. run scoreboard players set haunted_rooms game 0
execute if score state game matches 2 if score haunted_rooms settings matches 1 run function haunted:tick

execute if score state game matches 2 if score events settings matches 1 run scoreboard players add events game 1

execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 0 as @a[tag=seeker,scores={hit1=1..}] at @s as @a[tag=hider,scores={get_hit1=1..}] run tellraw @a ["",{"selector":"@s"},{"text":" has been eliminated"}]
execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 0 as @a[tag=seeker,scores={hit1=1..}] at @s as @a[tag=hider,scores={get_hit1=1..}] run function hiding:unfrozen
execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 0 as @a[tag=seeker,scores={hit1=1..}] at @s as @a[tag=hider,scores={get_hit1=1..}] run scoreboard players set @s killed 1
execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 1 as @a[tag=seeker,scores={hit1=1..}] at @s as @a[tag=hider,scores={get_hit1=1..}] run tellraw @a ["",{"selector":"@s"},{"text":" has be come a seeker"}]
execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 1 as @a[tag=seeker,scores={hit1=1..}] at @s as @a[tag=hider,scores={get_hit1=1..}] run function hiding:unfrozen
execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 1 as @a[tag=seeker,scores={hit1=1..}] at @s as @a[tag=hider,scores={get_hit1=1..}] run tag @s add seeker
execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 1 as @a[tag=seeker,scores={hit1=1..}] at @s as @a[tag=hider,scores={get_hit1=1..}] run team join seeker @s
execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 1 as @a[tag=seeker,scores={hit1=1..}] at @s as @a[tag=hider,scores={get_hit1=1..}] run tag @s remove hider

execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 2 as @a[tag=initseeker,scores={hit1=1..}] at @s as @a[tag=hider,scores={get_hit1=1..}] at @s run function hiding:frozen
execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 2 as @a[tag=hider,scores={hit1=1..}] at @s as @a[team=frozen,scores={get_hit1=1..}] at @s run tellraw @a ["",{"selector":"@s"},{"text":" has been unfrozen"}]
execute if score state game matches 2 unless score gamemode settings matches 3 if score caught_penalty settings matches 2 as @a[tag=hider,scores={hit1=1..}] at @s as @a[team=frozen,scores={get_hit1=1..}] at @s run function hiding:unfrozen

execute as @a[scores={hit1=1..}] at @s run scoreboard players reset @s hit1
execute as @a[scores={get_hit1=1..}] at @s run scoreboard players reset @s get_hit1
execute as @a[scores={killed=1..}] at @s run gamemode spectator @s
execute as @a[scores={killed=1..}] at @s run spawnpoint @s ~ ~ ~
execute as @a[scores={killed=1..},tag=seeker] at @s run tellraw @a ["",{"selector":"@s"},{"text":" was a seeker!","color":"yellow"}]
execute as @a[scores={killed=1..},tag=seeker] at @s run tag @s add spectate
execute as @a[scores={killed=1..},tag=seeker] at @s run team join spectate @s
execute as @a[scores={killed=1..},tag=seeker] at @s run tag @s remove seeker
execute as @a[scores={killed=1..},tag=hider] at @s run tag @s add spectate
execute as @a[scores={killed=1..},tag=hider] at @s run team join spectate @s
execute as @a[scores={killed=1..},tag=hider] at @s run tag @s remove hider
execute as @a[scores={killed=1..}] at @s run scoreboard players reset @s killed
effect give @a[gamemode=spectator] night_vision 999999 0 true

execute if score state game matches 2 if score release_delay game matches 1.. run scoreboard players remove release_delay game 1 
execute if score state game matches 2 unless score gamemode settings matches 3 if score release_delay game matches 0 run tellraw @a ["",{"text":"The Seekers have been released!","color":"gold"}]
execute if score state game matches 2 if score gamemode settings matches 3 if score release_delay game matches 0 run tellraw @a ["",{"text":"All players have received their weapons","color":"yellow"}]
execute if score state game matches 2 if score gamemode settings matches 3 if score release_delay game matches 0 run give @a iron_sword
execute if score state game matches 2 if score gamemode settings matches 3 if score release_delay game matches 0 run give @a golden_apple
execute if score state game matches 2 if score gamemode settings matches 3 if score release_delay game matches 0 run give @a[tag=seeker] golden_apple 2
execute if score state game matches 2 if score gamemode settings matches 3 if score release_delay game matches 0 run effect clear @a resistance
execute if score state game matches 2 if score gamemode settings matches 3 if score release_delay game matches 0 run effect clear @a weakness
execute if score state game matches 2 unless score gamemode settings matches 3 if score release_delay game matches 200 run tellraw @a ["",{"text":"Releasing the Seekers in 10...","color":"gold"}]
execute if score state game matches 2 unless score gamemode settings matches 3 if score release_delay game matches 100 run tellraw @a ["",{"text":"Releasing the Seekers in 5...","color":"gold"}]
execute if score state game matches 2 unless score gamemode settings matches 3 if score release_delay game matches 80 run tellraw @a ["",{"text":"Releasing the Seekers in 4...","color":"gold"}]
execute if score state game matches 2 unless score gamemode settings matches 3 if score release_delay game matches 60 run tellraw @a ["",{"text":"Releasing the Seekers in 3...","color":"gold"}]
execute if score state game matches 2 unless score gamemode settings matches 3 if score release_delay game matches 40 run tellraw @a ["",{"text":"Releasing the Seekers in 2...","color":"gold"}]
execute if score state game matches 2 unless score gamemode settings matches 3 if score release_delay game matches 20 run tellraw @a ["",{"text":"Releasing the Seekers in 1...","color":"gold"}]
execute if score state game matches 2 unless score gamemode settings matches 3 if score release_delay game matches 0 run spreadplayers 115 -180 1 6 false @a[tag=seeker]
execute if score state game matches 2 if score release_delay game matches 0 run summon lightning_bolt 115 22 -180
execute if score state game matches 2 if score release_delay game matches 0 run effect clear @a weakness
execute if score state game matches 2 if score release_delay game matches 0 run effect clear @a resistance
execute if score state game matches 2 if score release_delay game matches 0 if score gamemode settings matches 3 run effect clear @a regeneration
execute if score state game matches 2 if score release_delay game matches 0 run function game:timers/round
execute if score state game matches 2 if score gamemode settings matches 1 if score release_delay game matches 0 run function hiding:freeze
execute if score state game matches 2 if score release_delay game matches 0 run scoreboard players reset release_delay game
execute if score state game matches 2 if score round_length game matches 1.. run scoreboard players remove round_length game 1

execute if score state game matches 2 store success score seekerC game if entity @a[tag=seeker]
execute if score state game matches 2 store success score hiderC game if entity @a[tag=hider]
execute if score state game matches 2 if score seekerC game > hiderC game run scoreboard players add end game 1
execute if score state game matches 2 if score seekerC game < hiderC game run scoreboard players add end game 1
execute if score state game matches 2 if score seekerC game = hiderC game unless score round_length game matches 0 run scoreboard players set end game 0
execute if score state game matches 2 if score seekerC game > hiderC game if score end game matches 1 run tellraw @a ["",{"text":"Seekers have Won! ","color":"gold"},{"text":"(","color":"gray"},{"selector":"@a[tag=initseeker]"},{"text":")","color":"gray"}]
execute if score state game matches 2 if score seekerC game < hiderC game if score end game matches 1 run tellraw @a ["",{"text":"Hiders have Won! ","color":"gold"},{"text":"(","color":"dark_gray"},{"selector":"@a[team=hider]"},{"text":")","color":"dark_gray"}]
execute if score state game matches 2 if score round_length game matches 0 run scoreboard players add end game 1
execute if score state game matches 2 if score round_length game matches 0 if score end game matches 1 run tellraw @a ["",{"text":"Hiders have Won, The seekers ran out of time.","color":"gold"}]
execute if score state game matches 2 if score round_length game matches 0 if score end game matches 1 run effect give @a[tag=hider] glowing 99999 0 true
execute if score state game matches 2 if score end game matches 1 run tellraw @a ["",{"text":"Sending all back to lobby in 5 seconds...","color":"yellow"}]
execute if score state game matches 2 if score end game matches 1.. run scoreboard players reset * haunted_rooms
execute if score state game matches 2 if score end game matches 1.. run scoreboard players reset haunted_rooms game
execute if score state game matches 2 if score end game matches 100.. run function game:end

############################## Gamemodes 

execute if score state game matches 2 if score gamemode settings matches 3 as @a[tag=seeker] if entity @s[nbt=!{SelectedItem:{id:"minecraft:iron_sword",Count:1b}}] run effect clear @s strength
execute if score state game matches 2 if score gamemode settings matches 3 as @a[tag=seeker] if entity @s[nbt={SelectedItem:{id:"minecraft:iron_sword",Count:1b}}] run effect give @s strength 999999 10 true

execute if score state game matches 2 if score gamemode settings matches 1..2 as @a[tag=frozen] at @s unless entity @e[type=minecraft:area_effect_cloud,limit=1,tag=frozen,distance=..1.5] run particle cloud ~ ~.5 ~ .5 .5 .5 0 10 force @s
execute if score state game matches 2 if score gamemode settings matches 1..2 as @a[tag=frozen] at @s unless entity @e[type=minecraft:area_effect_cloud,limit=1,tag=frozen,distance=..1.5] run playsound minecraft:block.piston.extend master @s ~ ~ ~ 0.5 2
execute if score state game matches 2 if score gamemode settings matches 1..2 as @a[tag=frozen] at @s unless entity @e[type=minecraft:area_effect_cloud,limit=1,tag=frozen,distance=..1.5] as @e[type=minecraft:area_effect_cloud,limit=1,tag=frozen,sort=nearest] at @s run tp @a[tag=frozen,distance=..2,limit=1,sort=nearest] ~ ~ ~
execute if score state game matches 2 if score gamemode settings matches 1..2 as @a[tag=frozen] at @s unless entity @e[type=minecraft:area_effect_cloud,limit=1,tag=frozen,distance=..1.6] run tp @s @e[type=minecraft:area_effect_cloud,limit=1,tag=frozen,sort=nearest]