#powerup functions
execute as @a[scores={slowball=1..}] at @s run scoreboard players set @s slowthrow 15
execute as @a[scores={slowball=1..}] at @s run tag @s add slowthrow
execute as @e[type=snowball] at @s run effect give @a[distance=0.001..2,tag=!slowthrow] slowness 7 2 true
execute if score gamemode settings matches 2 as @e[type=snowball] at @s as @a[tag=!slowthrow,distance=0.001..2,tag=!frozen,tag=hider] at @s run function hiding:frozen
execute if score gamemode settings matches 2 as @e[type=snowball] at @s as @a[tag=!slowthrow,distance=0.001..2,tag=frozen,tag=hider] at @s run function hiding:unfrozen
execute as @a[scores={slowball=1..}] at @s run scoreboard players reset @s slowball
execute as @a[scores={slowthrow=1..}] at @s run scoreboard players remove @s slowthrow 1
execute as @a[scores={slowthrow=0}] at @s run tag @s remove slowthrow
execute as @a[scores={slowthrow=0}] at @s run scoreboard players reset @s slowthrow

execute as @a[scores={beartrap=1..}] at @s run tag @e[type=item,sort=nearest,limit=1,nbt={Item:{id:"minecraft:iron_trapdoor",Count:1b}}] add trap
execute as @a[scores={beartrap=1..}] at @s run scoreboard players reset @s beartrap
execute as @e[type=item,tag=trap,nbt={OnGround:1b}] at @s align xyz run summon area_effect_cloud ~.5 ~ ~.5 {Duration:99999,Tags:["trap"]}  
execute as @e[type=item,tag=trap,nbt={OnGround:1b}] at @s run kill @s

execute as @e[type=area_effect_cloud,tag=trap] at @s align xyz run particle minecraft:item iron_trapdoor ~.5 ~ ~.5 0.1 0.1 0.3 0 1 force @a
execute as @e[type=area_effect_cloud,tag=trap,tag=!triggered] at @s positioned ~.5 ~ ~.5 if entity @a[distance=..0.9,limit=1] run summon minecraft:evoker_fangs ~-.5 ~ ~-.5
execute as @e[type=area_effect_cloud,tag=trap,tag=!triggered] at @s positioned ~.5 ~ ~.5 if entity @a[distance=..0.9,limit=1] run effect give @p[limit=1,distance=..0.9] glowing 1 0 true
execute as @e[type=area_effect_cloud,tag=trap,tag=!triggered] at @s positioned ~.5 ~ ~.5 if entity @a[distance=..0.9,limit=1,tag=hider] run data merge entity @s {Duration:100}
execute as @e[type=area_effect_cloud,tag=trap,tag=!triggered] at @s positioned ~.5 ~ ~.5 if entity @a[distance=..0.9,limit=1,tag=hider] run effect give @p[limit=1,distance=..0.9] slowness 1 250 true
execute as @e[type=area_effect_cloud,tag=trap,tag=!triggered] at @s positioned ~.5 ~ ~.5 if entity @a[distance=..0.9,limit=1,tag=seeker] run effect give @p[limit=1,distance=..0.9] slowness 5 250 true
execute as @e[type=area_effect_cloud,tag=trap,tag=!triggered] at @s positioned ~.5 ~ ~.5 if entity @a[distance=..0.9,limit=1] run tag @s add triggered
execute as @e[type=area_effect_cloud,tag=trap,tag=triggered] at @s run tp @a[distance=..1,limit=1,sort=nearest] ~ ~ ~
execute as @e[type=area_effect_cloud,tag=trap,tag=triggered] at @s run kill @s

execute as @a[nbt={SelectedItem:{id:"minecraft:sugar"}}] at @s unless entity @e[type=villager,tag=sugaruse,distance=..2] run summon villager ^ ^.1 ^.5 {NoAI:1b,Invulnerable:1b,Silent:1b,ActiveEffects:[{Id:14b,Duration:9999,ShowParticles:0b}],Tags:["sugaruse","powerupuse"]}
execute as @a[nbt={SelectedItem:{id:"minecraft:sugar"}}] at @s run tp @e[type=villager,tag=sugaruse,distance=..2,sort=nearest,limit=1] ^ ^.1 ^.5
execute as @e[type=villager,tag=sugaruse] at @s unless entity @a[nbt={SelectedItem:{id:"minecraft:sugar"}},limit=1,distance=..2] run tp @s ~ ~-1000 ~

execute as @a[nbt={SelectedItem:{id:"minecraft:glowstone_dust"}}] at @s unless entity @e[type=villager,tag=glowuse,distance=..2] run summon villager ^ ^.1 ^.5 {NoAI:1b,Invulnerable:1b,Silent:1b,ActiveEffects:[{Id:14b,Duration:9999,ShowParticles:0b}],Tags:["glowuse","powerupuse"]}
execute as @a[nbt={SelectedItem:{id:"minecraft:glowstone_dust"}}] at @s run tp @e[type=villager,tag=glowuse,distance=..2,sort=nearest,limit=2] ^ ^.1 ^.5
execute as @e[type=villager,tag=glowuse] at @s unless entity @a[nbt={SelectedItem:{id:"minecraft:glowstone_dust"}},limit=1,distance=..2] run tp @s ~ ~-1000 ~

execute as @a[nbt={SelectedItem:{id:"minecraft:firework_rocket"}}] at @s unless entity @e[type=villager,tag=launchuse,distance=..2] run summon villager ^ ^.1 ^.5 {NoAI:1b,Invulnerable:1b,Silent:1b,ActiveEffects:[{Id:14b,Duration:9999,ShowParticles:0b}],Tags:["launchuse","powerupuse"]}
execute as @a[nbt={SelectedItem:{id:"minecraft:firework_rocket"}}] at @s run tp @e[type=villager,tag=launchuse,distance=..2,sort=nearest,limit=1] ^ ^.1 ^.5
execute as @e[type=villager,tag=launchuse] at @s unless entity @a[nbt={SelectedItem:{id:"minecraft:firework_rocket"}},limit=1,distance=..2] run tp @s ~ ~-1000 ~

execute as @a[nbt={SelectedItem:{id:"minecraft:note_block"}}] at @s unless entity @e[type=villager,tag=noise,distance=..2] run summon villager ^ ^.1 ^.5 {NoAI:1b,Invulnerable:1b,Silent:1b,ActiveEffects:[{Id:14b,Duration:9999,ShowParticles:0b}],Tags:["noise","powerupuse"]}
execute as @a[nbt={SelectedItem:{id:"minecraft:note_block"}}] at @s run tp @e[type=villager,tag=noise,distance=..2,sort=nearest,limit=1] ^ ^.1 ^.5
execute as @e[type=villager,tag=noise] at @s unless entity @a[nbt={SelectedItem:{id:"minecraft:note_block"}},limit=1,distance=..2] run tp @s ~ ~-1000 ~

execute as @a[nbt={SelectedItem:{id:"minecraft:compass"}}] at @s unless entity @e[type=villager,tag=compass,distance=..2] run summon villager ^ ^.1 ^.5 {NoAI:1b,Invulnerable:1b,Silent:1b,ActiveEffects:[{Id:14b,Duration:9999,ShowParticles:0b}],Tags:["compass","powerupuse"]}
execute as @a[nbt={SelectedItem:{id:"minecraft:compass"}}] at @s run tp @e[type=villager,tag=compass,distance=..2,sort=nearest,limit=1] ^ ^.1 ^.5
execute as @e[type=villager,tag=compass] at @s unless entity @a[nbt={SelectedItem:{id:"minecraft:compass"}},limit=1,distance=..2] run tp @s ~ ~-1000 ~

team join hider @e[type=villager,tag=powerupuse]
scoreboard objectives remove noteblock

execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:glowstone_dust"}},tag=hider] at @s run effect give @a[limit=1,sort=nearest,tag=seeker] glowing 5 0 true
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:glowstone_dust"}},tag=seeker] at @s run effect give @a[limit=1,sort=nearest,tag=hider] glowing 1 0 true
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:glowstone_dust"}},tag=seeker] at @s run playsound minecraft:block.bell.resonate master @s
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:glowstone_dust"}}] at @s run clear @s glowstone_dust 1
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:sugar"}}] at @s run effect give @s speed 5 1 true
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:sugar"}}] at @s run clear @s sugar 1
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:sugar"}}] at @s run playsound minecraft:entity.player.burp master @s
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:firework_rocket"}}] at @s if block ~ ~-1 ~ air run tellraw @s ["",{"text":"This item can only be used on the ground.","color":"red"}]
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:firework_rocket"}}] at @s unless block ~ ~-1 ~ air run effect give @s levitation 3 3 true
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:firework_rocket"}}] at @s unless block ~ ~-1 ~ air run clear @s firework_rocket 1
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:firework_rocket"}}] at @s unless block ~ ~-1 ~ air run playsound minecraft:entity.firework_rocket.launch master @s
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:note_block"}},tag=hider] at @s run scoreboard players set @s voiceless 100
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:note_block"}},tag=seeker] at @e[tag=hider] run playsound minecraft:entity.cat.stray_ambient master @s[tag=seeker] ~ ~ ~
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:note_block"}}] at @s run clear @s note_block 1
execute as @a[scores={powerup=1..},nbt={SelectedItem:{id:"minecraft:compass"}}] at @s run function haunted:reveal

execute as @a[scores={voiceless=1..},tag=hider] at @s run scoreboard players remove @s voiceless 1
execute as @a[scores={voiceless=1..},tag=hider] at @s run function hiding:voiceless
execute as @a[scores={voiceless=0},tag=hider] at @s run scoreboard players reset @s voiceless
execute as @a[scores={powerup=1..}] at @s run scoreboard players reset @s powerup